#
#   -   (-)
#
proc do_first_authorize {} {
    global state
    global pin
    global account

    set account {}
    set pin {}

    set ev [authorize $account $pin {} [ani] info]

    switch -regexp $ev {
    {authorized} {
	    set state do_get_did
	}
    {authorization failed} {
	    set state do_fail
	}
    default {
	    set state end
	}
    }
    return 0
}

#
#     (did)
#
proc do_get_did {} {
    global state
    global destination

    if {[did]} {
        set destination [string range [dnis] 2 end]
	puts "\t\t**** got: $destination"
	switch -regexp $destination {
	    {^[78]2[0-9][0-9][0-9][0-9][0-9][0-9][0-9]$} {
		set destination 6767#7347[string range $destination 2 end]
		}
	    {^810[0-9]+$} {
		set destination 6666#[string range $destination 3 end]
		}
	    {^81[0-9]+$} {
		set destination 6666#[string range $destination 2 end]
		}
	    {^[78][0-9]+$} {
		set destination 6767#7[string range $destination 1 end]
		}
	    default {
		set destination 6666#$destination
	    }
	}
	puts "\t\t**** set: $destination"
	set state do_second_authorize
    } else {
	set state end
    }

    return 0
}


#
#   .     .
#
proc do_second_authorize {} {
    global state
    global destination
    global account
    global pin
    global creditTime
    global no_time_limit

    #   
    set ev [authorize $account $pin $destination [ani] info]

    switch -regexp $ev {
    {authorized} {
	    if {[getVariable aaa h323-credit-time info] != 0} {
		puts "\t\t**** got h323-credit-time: $info(0)"
		set creditTime $info(0)
	    } {
		puts "\t\t**** can't get h323-credit-amount"
		set creditTime "uninitialized"
	    }

	    if {$creditTime == "uninitialized"} {
		set state do_fail
	    } elseif {$creditTime == "unlimited"} {
		set no_time_limit 1
		set state do_place_call
	    } {
		set state do_place_call
	    }
	}
    {authorization failed} {
	    set state do_fail
	}
    default {
	    set state end
	}
    }
    return 0
}

#
# 
#
proc do_place_call {} {
    global state
    global destination
    global account

    set callInfo(accountNum) $account

    set ev [placeCall $destination callInfo info]

    switch -regexp $ev {
    {active} {
	    set state do_active
	}
    {call fail} {
	    set state do_place_fail
	}
    default {
	    set state end
	}
    }
    return 0
}

#
#   ( )
#
proc do_active_notimer {} {
    global state

    set ev [waitEvent]

    while {$ev == "digit"} {
	set ev [waitEvent]
    }
    set state end
    return 0
}

#
#   ( )?
#
proc do_active_last_timer {} {
    global state
    global warnTime
    global creditTime
    global no_play

    if {$no_play == 1} {
	set ev [startTimer [expr {$creditTime - 1}] info]
    } {
	set ev [startTimer [expr {$warnTime - 4}] info]
    }

    while {$ev == "digit"} {
	set ev [startTimer $info(timeLeft) info]
    }

    switch -regexp $ev {
    {longpound} {
	    do_longpound
	    return 0
	}
    {timeout} {
	    clearOutgoingLeg info
	    set state do_out_of_time
	}
    default {
	    set state end
	}
    }
    return 0
}

#
#  longpound'
#
proc do_longpound {} {
    global state

    clearOutgoingLeg info
    set state do_fail

    return 0
}

#
# dunno
#
proc do_active_timer {} {
    global state
    global warnTime
    global creditTime
    global no_play

    set delay [expr {$creditTime - $warnTime}]
    set ev [startTimer $delay info]

    while {$ev == "digit"} {
	set ev [startTimer $info(timeLeft) info]
    }

    switch -regexp $ev {
    {longpound} {
	    do_longpound
	    return 0
	}
    {outgoing disconnected} {
	    set state do_fail
	}
    {timeout} {
	    if {$no_play != 1} {
		set warnTime [string trimleft $warnTime]
		playTone Disconnect
		startTimer 2 timer
		playTone None
	    }
	    do_active_last_timer
	}
    default {
	    set state end
	}
    }
    return 0
}

#
# dunno
#
proc do_active {} {
    global state
    global creditTime
    global warnTime
    global no_time_limit

    if {($no_time_limit == 1) ||($creditTime == "unlimited") ||($creditTime == "uninitialized")} {
	do_active_notimer
    } {
	if {$creditTime < $warnTime} {
	    do_active_last_timer
	} {
	    do_active_timer
	}
    }
    return 0
}

#
#    
#
proc do_out_of_time {} {
    global state

    set state do_fail
    return 0
}

#
#   
#
proc do_place_fail {} {
    global state

    playTone "Out Of Service"
    startTimer 2 timer
    playTone None

    set state end

    return 0
}

#
#  
#
proc do_fail {} {
    global state

    playTone Disconnect
    startTimer 2 timer
    playTone None

    set state end

    return 0
}


#-------------------------------------------------------
# main
#

acceptCall

# set primary language
setVariable language 1

# set "longpound" feature
setVariable longPound true

set no_play 0
set no_time_limit 0
set destination 0900405

# collect digits, use dial plan, may be interrupted
set pr_input(interrupt) true
set pr_input(abortKey) *
set pr_input(terminationKey) #
set pr_input(dialPlan) true

# get global configuration parameters from AS5xxx
set warnTime [getVariable config warningTime]

set state do_first_authorize

while {$state != "end"} {
    puts "************ cid([callID]) app running state $state"
    $state
}

